using System;

using Client.CircularRefs;

namespace Client {
    class Program {
        static void Main() {
            IPersonService svc = new PersonServiceClient();
            PersonDTO p = svc.GetDefaultPerson();
            Console.WriteLine(formatPerson(p));
            Console.WriteLine("Press <ENTER> to exit");
            Console.ReadLine();
        }

        private static string formatPerson(PersonDTO p) {
            return formatPerson(p, 0);
        }

        private static string formatPerson(PersonDTO p, int indentLevel) {
            string indent = new string('\t', indentLevel);
            string retval = string.Format("{0}{1} - My parent is {2}.\r\n", indent, p.Name, p.Parent.Name);
            foreach(PersonDTO child in p.Children) {
                retval += formatPerson(child, indentLevel + 1);
            }
            return retval;
        }
    }
}
