using System;
using System.IO;
using System.Runtime.Serialization;

using NUnit.Framework;

namespace JamesKovacs.Examples.WcfCircularRefs.DTO.Test {
    [TestFixture]
    public class PersonDTOTests {
        [Test]
        public void ShouldBeAbleToSerializePersonDTO() {
            string parentName = "Sam Spade";
            PersonDTO person = new PersonDTO(parentName);
            person.AddChild("Jane Spade");
            person.AddChild("Bobby Spoon");
            using(MemoryStream memStream = new MemoryStream()) {
                DataContractSerializer serializer = new DataContractSerializer(typeof(PersonDTO), null, int.MaxValue, false, true /* preserveObjectReferences */, null);
                serializer.WriteObject(memStream, person);
                memStream.Seek(0, SeekOrigin.Begin);
                StreamReader reader = new StreamReader(memStream);
                Console.WriteLine(reader.ReadToEnd());
                memStream.Seek(0, SeekOrigin.Begin);
                PersonDTO rehydrated = (PersonDTO)serializer.ReadObject(memStream);
                Assert.AreEqual(parentName, rehydrated.Name);
                Assert.AreEqual(2, rehydrated.Children.Count);
            }
        }
    }
}
