using System;
using System.ServiceModel;

using JamesKovacs.Examples.WcfCircularRefs.DTO;

using Thinktecture.ServiceModel;

namespace JamesKovacs.Examples.WcfCircularRefs.Service {
    [ServiceContract(Namespace="http://www.jameskovacs.com/Examples/WcfCircularRefs")]
    public interface IPersonService {
        [OperationContract]
        [PreserveReferences]
        PersonDTO GetDefaultPerson();
    }

    public class PersonService : IPersonService {
        public PersonDTO GetDefaultPerson() {
            return createDefaultPerson();
        }

        private PersonDTO createDefaultPerson() {
            PersonDTO parent = new PersonDTO("Sam Spade");
            parent.AddChild("Jane Spade");
            parent.AddChild("Bobby Spoon");
            return parent;
        }
    }

    internal class PersonServiceHost {
        internal static ServiceHost myServiceHost = null;

        internal static void Main() {
            // Consider putting the baseAddress in the configuration system
            // and getting it here with AppSettings
            Uri baseAddress = new Uri("http://localhost:8080/JamesKovacs.Examples.WcfCircularRefs/PersonService");

            // Instantiate new ServiceHost 
            myServiceHost = new ServiceHost(typeof(PersonService), baseAddress);

            myServiceHost.Open();
            Console.WriteLine("Press <ENTER> to exit");
            Console.ReadLine();
            if(myServiceHost.State != CommunicationState.Closed)
                myServiceHost.Close();
        }
    }
}

