/*
 * Ingo Rammer, thinktecture
 * http://msdn2.microsoft.com/en-us/library/aa730857(VS.80).aspx#netremotewcf_topic8
*/

using System;
using System.ServiceModel.Channels;
using System.ServiceModel.Description;
using System.ServiceModel.Dispatcher;

namespace Thinktecture.ServiceModel {
    public class PreserveReferencesAttribute : Attribute, IOperationBehavior {
        public void AddBindingParameters(OperationDescription description,
          BindingParameterCollection parameters) { }

        public void ApplyClientBehavior(OperationDescription description,
          ClientOperation proxy) {
            IOperationBehavior innerBehavior =
              new PreserveReferencesOperationBehavior(description);
            innerBehavior.ApplyClientBehavior(description, proxy);
        }

        public void ApplyDispatchBehavior(OperationDescription description,
          DispatchOperation dispatch) {
            IOperationBehavior innerBehavior =
              new PreserveReferencesOperationBehavior(description);
            innerBehavior.ApplyDispatchBehavior(description, dispatch);
        }

        public void Validate(OperationDescription description) { }
    }
}
