/*
 * Ingo Rammer, thinktecture
 * http://msdn2.microsoft.com/en-us/library/aa730857(VS.80).aspx#netremotewcf_topic8
*/

using System;
using System.Collections.Generic;
using System.Runtime.Serialization;
using System.ServiceModel.Description;
using System.Xml;

namespace Thinktecture.ServiceModel {
    public class PreserveReferencesOperationBehavior :
       DataContractSerializerOperationBehavior {

        public PreserveReferencesOperationBehavior(
          OperationDescription operationDescription)
            : base(operationDescription) { }

        public override XmlObjectSerializer CreateSerializer(
          Type type, string name, string ns, IList<Type> knownTypes) {
            return CreateDataContractSerializer(type, name, ns, knownTypes);
        }

        private static XmlObjectSerializer CreateDataContractSerializer(
          Type type, string name, string ns, IList<Type> knownTypes) {
            return CreateDataContractSerializer(type, name, ns, knownTypes);
        }

        public override XmlObjectSerializer CreateSerializer(
          Type type, XmlDictionaryString name, XmlDictionaryString ns,
          IList<Type> knownTypes) {
            return new DataContractSerializer(type, name, ns, knownTypes,
                0x7FFF,
                false,
                true /* preserveObjectReferences */,
                null);
        }
    }
}